#include <wgt5.h>
#include <wgtscrol.h>

#include <string.h>
#include <stdio.h>

/* A small utility that breaks a 512x512 image into 256 smaller 32x32
  tiles.  It puts these in a sprite file for our terrain, and also creates
  a 128x128 map file with this texture repeated across it.

  Requires Watcom and WGT 5.1 to recompile
*/



block img;
color pal[256];
block sprites[257];

wgtmap   map;
short    tiletypes[257];
scrollsprite wobjects[10];

int i, j;


void main (void)
{
  vga256 ();

  /* First create the tiles */

  img = wloadpcx ("erode.pcx", pal);
  wsetpalette (0, 255, pal);

  wsetscreen (img);

  sprites[0] = NULL;

  for (i = 0; i < 16; i++)
    for (j = 0; j < 16; j++)
      sprites[i*16+j+1] = wnewblock (j*32, i*32, j*32+31, i*32+31);

  wsavesprites (pal, "tiles.spr", sprites, 0, 257);



  /* Now create the map */
  map = (wgtmap)malloc (128*128*2);
  memset (map, 0, 128*128*2);

  for (i = 0; i < 128; i++)
    for (j = 0; j < 128; j++)
      map[i * 128 + j] = ((j % 16) + (i % 16)*16) + 1;

  /* Set up the internal map dimensions */
  mapwidth[0] = 128;
  mapheight[0] = 128;
  wsavemap (0, "map.wmp", map, tiletypes, wobjects, 1);

  wsetmode (3);
}





