PR_DWORD  device=0;                    /* Display device */

void InitializeDevices (void)
{
#if defined (MSGL) || defined (WTGL)
  if ((device == DEVICE_GL) || (device == DEVICE_ANY))
    device = PR_DetectGL();
#endif



#ifdef __MYST__
  if ((device == DEVICE_MYSTIQUE) || (device == DEVICE_ANY))
    device = PR_DetectMystique ();
#endif


#ifdef __3DFX__
  if ((device == DEVICE_3DFX) || (device == DEVICE_ANY))
    device = PR_Detect3Dfx ();
#endif

#if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
  #if defined (MSDD) || defined (WTDD)
    if ((device == DEVICE_D3D) || (device == DEVICE_ANY))
      device = PR_DetectD3D ();   /* Attempt to find the device */
  #endif

  if ((device == DEVICE_SVGA) || (device == DEVICE_ANY))
    device = PR_DetectSVGA ();   /* Attempt to find the device */

  if ((device == DEVICE_VGA) || (device == DEVICE_ANY))
    device = PR_DetectVGA ();   /* Attempt to find the device */
#endif


#if defined (MSGL) || defined (WTGL)
  if (device == DEVICE_GL)
    {
     PR_InitializeGL ();
     atexit (PR_ShutdownGL);
    }
#endif

#ifdef __MYST__
  if (device == DEVICE_MYSTIQUE)
    {
     PR_InitializeMystique ();
     atexit (PR_ShutdownMystique);
    }
#endif

#ifdef __3DFX__
  if (device == DEVICE_3DFX)
    {
     PR_Initialize3Dfx ();
     atexit (PR_Shutdown3Dfx);
    }
#endif

#if !defined (MSGLIDE) && !defined (WTGLIDE) && !defined (MSGL) && !defined (WTGL)
  #if defined (MSDD) || defined (WTDD)
  if (device == DEVICE_D3D)
    {
     PR_InitializeD3D ();
     atexit (PR_ShutdownD3D);
    }
  #endif
  if (device == DEVICE_SVGA)
    {
     PR_InitializeSVGA ();
     atexit (PR_ShutdownSVGA);
    }
  else if (device == DEVICE_VGA)
    {
     PR_InitializeVGA ();
    }
#endif
}



#if defined (MSDD) || defined (WTDD)
void PR_RestoreAll (void)
{
HRESULT ddrval;
PR_DWORD i;
extern void resize (int width, int height);

  cx = GetSystemMetrics (SM_CXSCREEN);
  cy = GetSystemMetrics (SM_CYSCREEN);
  
  if (PR_Settings.UseWindowed)
    resize (cx, cy);


  ddrval = IDirectDrawSurface2_Restore (wgtpdds);
  if (ddrval != DD_OK)
    return;

 for (i = 0; i < PR_NumTextures; i++)
   {
    if (PR_WorldTextures[i].InCache)
      {
       IDirectDrawSurface2_Restore (PR_WorldTextures[i].image);

       if (PR_WorldTextures[i].HardwareImage != NULL)
       IDirectDrawSurface2_Restore (PR_WorldTextures[i].HardwareImage);
      }
   }


  PR_LostSurface = 0;
}
#endif



void ChooseDevice (void)
{
#ifndef WIN32
  while (kbhit ())
    getch ();

#if defined (__3DFX__) || defined (__MYST__)
  printf ("Use 3D hardware? (y/n)\n");
  device = getch ();

  if (device == 'y' || device == 'Y')
    device = DEVICE_ANY;
  else
#endif
     device = DEVICE_SVGA;
#else /* We are in windows */

  #if defined(MSDD) || defined(WTDD)
    device = DEVICE_D3D;
  #elif defined(MSGL) || defined(WTGL)
    device = DEVICE_GL;
  /* Next look for specific hardware */
  #elif defined (MSGLIDE) || defined (WTGLIDE)
    device = DEVICE_3DFX;
  #elif defined (MSMYST) || defined (WTMYST)
    device = DEVICE_MYST;
  #endif
#endif
}



/* Same as above but does not ask for 3Dfx in DOS.
   This is used by the command line driven utilities */
void ChooseDeviceSoftware (void)
{
#ifndef WIN32
  while (kbhit ())
    getch ();

  device = DEVICE_VGA;
#else /* We are in windows */

  #if defined(MSDD) || defined(WTDD)
    device = DEVICE_D3D;
  #elif defined(MSGL) || defined(WTGL)
    device = DEVICE_GL;
  /* Next look for specific hardware */
  #elif defined (MSGLIDE) || defined (WTGLIDE)
    device = DEVICE_3DFX;
  #elif defined (MSMYST) || defined (WTMYST)
    device = DEVICE_MYST;
  #endif
#endif
}


void ChooseGUI (void)
{
#ifndef WIN32
 #ifdef __3DFX__
   if (device == DEVICE_3DFX)
     PRGUI_Initialize3Dfx ();
 #endif
 #ifdef __MYST__
   if (device == DEVICE_MYSTIQUE)
     PRGUI_InitializeMystique ();
#endif
   if (device == DEVICE_SVGA)
   PRGUI_InitializeSVGA ();
#endif

#ifdef WIN32
  #if defined (MSGLIDE) || defined (WTGLIDE)
     PRGUI_Initialize3Dfx ();
  #endif
  #if defined (MSGL) || defined (WTGL)
     PRGUI_InitializeGL ();
  #endif
  #if defined (MSDD) || defined (WTDD)
    if (device == DEVICE_D3D)
      PRGUI_InitializeD3D ();
    else
      PRGUI_InitializeSVGA ();
  #endif
#endif
}
