#include <stdlib.h>
#include <direct.h>
#include <string.h>
#include <conio.h>

#include <pr.h>

#if defined (MSGLIDE) || defined (WTGLIDE)
 #include <glide.h>
 #include <pr3dfx.h>
 #include "winutil.h"
 #include <windows.h>
#elif defined (WIN32)
 #include "winutil.h"
 #include <windows.h>
#else
 #ifdef __3DFX__
  #include <pr3dfx.h>
  #include <glide.h>
 #endif
#endif

#include <prgui.h>

#include <prdev.h>


/*

SetRGB Utility

Sets the rendering methods of a PRO file to RGB_TEXTURED or RGB_GOURAUD
depending on the current methods used.

 Revision History:
 May 1998: Created

*/

char outfile[80];               /* Name of the output file */
PR_OBJECT *object1;
PR_DWORD device;


void main (int argc, char *argv[])
{
PR_MATERIAL *mat;
PR_DWORD i;
  PRGUI_InitPath (argv[0]);


  if (argc < 3)
    {
     PR_FatalError (
                "SETRGB Utility    version "
                PR_VERSION_NUMBER
                "\nCopyright 1998 Egerter Software\n\n"
		"Usage: \n"
        "setrgb file1.PRO file2.PRO\n", "setrgb");
    }

  printf ("SETRGB Utility    version ");
  printf (PR_VERSION_NUMBER);
  printf ("\nCopyright 1998 Egerter Software\n\n");


  ChooseDeviceSoftware ();

  PR_Initialize (50);
  InitializeDevices ();


  PR_AllocMaterials (512);
  PR_AllocTextures (255);
  PR_AllocShadeTables (32);


  object1 = PR_LoadPRO (argv[1], LOAD_NORMAL);
  if (object1 == NULL)
     PR_FatalError ("An error has occurred when loading the file.\n", "SETRGB");

  for (i = 0; i < LPRO_ImportMaterialCount; i++)
    {
     mat = &PR_ObjectMaterialList[i];

     if ((mat->render_method == T_PWTEXTURED) ||
        (mat->render_method == T_WTEXTURED))
       {
        mat->r = 255;
        mat->g = 255;
        mat->b = 255;
        mat->a = 255;
        mat->render_method = T_RGB_TEXTURED;
       }
     if (mat->render_method == T_GOURAUD)
       {
        mat->render_method = T_RGB_GOURAUD;
       }
    }

  PR_SavePRO (argv[2], object1, SAVE_ALL_MATERIALS);

  PR_ShutDown ();

  #ifndef WIN32
    wsetmode (3);                        /* Go back to text mode */
  #endif
}



