#include <stdlib.h>
#include <direct.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

#include <pr.h>

#if defined (MSGLIDE) || defined (WTGLIDE)
 #include <glide.h>
 #include <pr3dfx.h>
 #include "winutil.h"
 #include <windows.h>
#elif defined (WIN32)
 #include "winutil.h"
 #include <windows.h>
#else
 #ifdef __3DFX__
  #include <pr3dfx.h>
  #include <glide.h>
 #endif
#endif

#include <prgui.h>

#include <prdev.h>

/*

Join PRO Utility

Combines the objects from two PRO files into one file.

 Revision History:
 July 18, 1996: Created

*/

char outfile[80];               /* Name of the output file */
PR_OBJECT *object1;
PR_OBJECT *object2;
PR_OBJECT *object3;             /* Output object */
PR_DWORD choice;


void main (int argc, char *argv[])
{
PR_SEGMENT *seg;
PR_ENTITY *ent;

  PRGUI_InitPath (argv[0]);

  printf ("SWAPSEG Utility    version ");
  printf (PR_VERSION_NUMBER);
  printf ("\nCopyright 1998 Egerter Software\n\n");

  if (argc < 4)
    {
     printf ("Usage: \n"
             "SWAPSEG file1.PRO segname file2.PRO outfile.pro\n");
	 
     #ifdef WIN32
	 PR_FatalError ("Usage: \n"
                    "SWAPSEG file1.PRO segname file2.PRO outfile.PRO\n",
                                        "SWAPSEG");
	 #endif
     exit (1);
    }

  if (PRGUI_FileExists (argv[4]))
    {
     #ifdef WIN32
     if (MessageBox(NULL, "The file already exists! Overwrite?\n",
                 "SWAPSEG", MB_OKCANCEL) != IDOK)
		exit (1);
	 #else

     printf ("%s already exists! Overwrite? (Y/N)\n",
            argv[4]);
     do {
       choice = toupper (getch ());
     } while (choice != 'N' && choice != 'Y');

     if (choice == 'N')
       exit (1);
	 #endif
    }


  ChooseDeviceSoftware ();
  
  PR_Initialize (50);
  InitializeDevices ();

  PR_AllocMaterials (512);
  PR_AllocTextures (255);
  PR_AllocShadeTables (32);

  object1 = PR_LoadPRO (argv[1], LOAD_NORMAL);
  if (object1 == NULL)
    PR_FatalError ("An error has occurred when loading the first file.", "SWAPSEG");

  object2 = PR_LoadPRO (argv[3], LOAD_NORMAL);
  if (object2 == NULL)
    PR_FatalError ("An error has occurred when loading the second file.", "SWAPSEG");

  ent = PR_CreateEntity (object1,  "tempent");

  seg = PR_FindSegment (ent, argv[2]);
  if (seg == NULL)
    PR_FatalError ("Cannot find segment in file.", argv[2]);

  seg->num_faces = object2->segment_list->num_faces;
  seg->num_vertices = object2->segment_list->num_vertices;
  if (seg->flags & FLAG_SUBSEG)
    object2->segment_list->flags |= FLAG_SUBSEG;
  seg->flags = object2->segment_list->flags;

  seg->vertex_list = object2->segment_list->vertex_list;
  seg->vertex_data = object2->segment_list->vertex_data;
  seg->face_list = object2->segment_list->face_list;
    
   
  PR_SavePRO (argv[4], object1, SAVE_ALL_MATERIALS);

  #ifndef WIN32
   wsetmode (3);                        /* Go back to text mode */
  #endif
}



