#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <assert.h>

#include <pr.h>

#if defined(MSGLIDE) || defined (WTGLIDE)
#include <glide.h>
#elif defined (MSDD) || defined (WTDD)
#include <wgt95.h>
#endif

/*
unfinished:
keyboard handling without dinput
mouse handling without dinput
fog textures
*/



#define USE_DIRECT_INPUT
#define USE_FULL_SCREEN
#define USE_ZBUFFER
//#define USE_BILINEAR

/* Use ALT F4 to quit in full screen mode */

#ifdef USE_DIRECT_INPUT
// #define DIRECTINPUT_VERSION 0x300
 #include <dinput.h>
#endif

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include "winutil.h"

#include <GL\gl.h>
#include <GL\glu.h>

#define TITLE "Power Render 2.6"


/* Forward declarations */
HWND hWndMain;
HINSTANCE  ghInstance;    /* My instance handle */
extern void PRGUI_InitPath (char *str);

char ** commandLineToArgv(LPSTR lpCmdLine, int *pArgc);

/* The following variables are used to simulate the input routines
   from WGT 5.1 */
char kbdon[256];
static int keyhead = 0;
static int keytail = 0;
static int keyqueue[256] = {0};

PR_MouseCallback_data mouse;
int PR_mx0, PR_my0, PR_mx1, PR_my1;

int PR_LostSurface = 1;


#ifdef USE_DIRECT_INPUT
 /* Direct Input */
 #define WM_SYNCACQUIRE      (WM_USER + 0)
 LPDIRECTINPUT          g_pdi = NULL;
 LPDIRECTINPUTDEVICE    g_pMouse;
 LPDIRECTINPUTDEVICE    g_pKeyboard;
 HANDLE                 g_hevtMouse;
#endif

int                    fKeybdAcquired;
int                    PR_AppActive;

#ifdef USE_DIRECT_INPUT
int minit (void)
{
HRESULT  err;
GUID        guid = GUID_SysMouse;

  if (g_pdi == NULL)
  {
   err = DirectInputCreate(ghInstance, DIRECTINPUT_VERSION, &g_pdi, NULL);
   if(FAILED(err))
   {
    MessageBox(NULL, "Unable to Create DirectInput Object",
                 TITLE, MB_OK);
      return FALSE;
   }
  }

  /* Obtain an interface to the system mouse device. */
  err = g_pdi->lpVtbl->CreateDevice(g_pdi, &guid, &g_pMouse, NULL);

  if (FAILED(err)) 
    {
     MessageBox(NULL, "Unable to Create DirectInput Mouse Device",
                TITLE, MB_OK);
     return FALSE;
    }

  /* Set the data format to "mouse format". */
  err = g_pMouse->lpVtbl->SetDataFormat(g_pMouse, &c_dfDIMouse);

  if (FAILED(err)) 
    {
     MessageBox(NULL, "Unable to Set Mouse Format",
                TITLE, MB_OK);
         return FALSE;
    }

  /* Set the cooperativity level. */
  err = g_pMouse->lpVtbl->SetCooperativeLevel(g_pMouse, hWndMain,
              DISCL_EXCLUSIVE | DISCL_FOREGROUND);

  if (FAILED(err)) 
    {
     MessageBox(NULL, "Unable to Set Cooperative Level",
                TITLE, MB_OK);
     return FALSE;
    }

  PR_mx0 = 0;
  PR_my0 = 0;
  PR_mx1 = 639;
  PR_my1 = 479;
  mouse.mx = 320;
  mouse.my = 240;
  mouse.but = 0;
return TRUE;
}




void mdeinit (void)
{
  if (g_pdi)      g_pdi   ->lpVtbl->Release(g_pdi), g_pdi    = NULL;
  if (g_pMouse)   g_pMouse->lpVtbl->Release(g_pMouse), g_pMouse = NULL;
}


void msetbounds (int x0, int y0, int x1, int y1)
{
  PR_mx0 = x0;
  PR_my0 = y0;
  PR_mx1 = x1;
  PR_my1 = y1;
}


void msetxy (int x0, int y0)
{
  mouse.mx = x0;
  mouse.my = y0;
}


void noclick (void)
{
  while (mouse.but)
    UpdateMessages ();
}


void PR_ReadMouse (void)
{
DIMOUSESTATE diMouseState;

  if (PR_AppActive)
    {
     if (g_pMouse->lpVtbl->GetDeviceState(g_pMouse,
                        sizeof(diMouseState), &diMouseState) == DI_OK) 
       {
        mouse.mx += (int)diMouseState.lX;
        mouse.my += (int)diMouseState.lY;
        mouse.but = (diMouseState.rgbButtons[0]>0) + 
                   ((diMouseState.rgbButtons[1]>0)<<1) +
                   ((diMouseState.rgbButtons[2]>0)<<2);
       }
    }

  /* Clip the cursor to our client area */
  if (mouse.mx < PR_mx0)
      mouse.mx = PR_mx0;
  if (mouse.mx > PR_mx1) 
      mouse.mx = PR_mx1;

  if (mouse.my < PR_my0)
      mouse.my = PR_my0;
  if (mouse.my > PR_my1) 
      mouse.my = PR_my1;

  /* !!! HACK -  Fixed bug in some cards which only accept dword aligned blts */
//  mouse.mx = (mouse.mx / 4) * 4;
}


void PR_MouseSyncAcquire (HWND hwnd)
{
    if (PR_AppActive) {
        if (g_pMouse) 
                        g_pMouse->lpVtbl->Acquire(g_pMouse);
    } else {
        if (g_pMouse) 
                        g_pMouse->lpVtbl->Unacquire(g_pMouse);
    }
//    InvalidateCursorRect(hwnd);
}



int installkbd (void)
{
GUID     guid = GUID_SysKeyboard;
HRESULT  err;

  if (g_pdi == NULL)
  {
   err = DirectInputCreate(ghInstance, DIRECTINPUT_VERSION, &g_pdi, NULL);
   if(FAILED(err))
   {
      MessageBox(NULL, "Unable to Create DirectInput Object",
                 TITLE, MB_OK);
      return FALSE;
   }
  }


  /* Obtain an interface to the system mouse device. */
  err = g_pdi->lpVtbl->CreateDevice(g_pdi, &guid, &g_pKeyboard, NULL);
  if (FAILED(err)) 
    {
     MessageBox(NULL, "Unable to Create DirectInput Keyboard Device",
                TITLE, MB_OK);
     return FALSE;
    }

  /* Set the data format to "mouse format". */
  err = g_pKeyboard->lpVtbl->SetDataFormat(g_pKeyboard, &c_dfDIKeyboard);

  if (FAILED(err)) 
    {
     MessageBox(NULL, "Unable to Set Keyboard Format",
                TITLE, MB_OK);
         return FALSE;
    }


  /* Set the cooperativity level. */
  err = g_pKeyboard->lpVtbl->SetCooperativeLevel(g_pKeyboard, hWndMain,
              DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);

  if (FAILED(err)) 
    {
     MessageBox(NULL, "Unable to Set Keyboard Cooperative Level",
                TITLE, MB_OK);
     return FALSE;
    }


    // try to acquire the keyboard
   err = g_pKeyboard->lpVtbl->Acquire(g_pKeyboard);
   if(SUCCEEDED(err))
   {
      // keyboard was acquired
      fKeybdAcquired = TRUE;
    }
   else
   {
      // keyboard was NOT acquired
      fKeybdAcquired = FALSE;
   }

    // if we get here, all objects were created successfully
    return TRUE;    
}




/*
*
* DI_ReadKeys
*
* Use DirectInput to read game-play keys
*
*/
void PR_ReadKeyboard(void)
{
HRESULT hRes;

  if (g_pKeyboard == NULL)
    return;

   hRes = g_pKeyboard->lpVtbl->GetDeviceState(g_pKeyboard, sizeof(kbdon), kbdon);
   if(hRes != DI_OK)
    {
      if(hRes == DIERR_INPUTLOST)
      {
         // we lost control of the keyboard, reacquire
         fKeybdAcquired = FALSE;
         if(SUCCEEDED(g_pKeyboard->lpVtbl->Acquire(g_pKeyboard)))
         {
            fKeybdAcquired = TRUE;
         }
      }

      // failed to read the keyboard, just return
        return;
    }
}

void uninstallkbd (void)
{
  if(fKeybdAcquired)
  {
   g_pKeyboard->lpVtbl->Unacquire(g_pKeyboard);
   fKeybdAcquired = FALSE;
  }

  if(g_pKeyboard != NULL)
    g_pKeyboard->lpVtbl->Release(g_pKeyboard);
  g_pKeyboard = NULL;
}


BOOL PR_KeyboardSyncAcquire (void)
{
    // try to acquire the keyboard
        if(g_pKeyboard != NULL)
          {
           g_pKeyboard->lpVtbl->Acquire(g_pKeyboard);
          }
        else
          {
                // keyboard device has not been created.
                fKeybdAcquired = FALSE;
                return FALSE;
          }
  
        // if we get here, we are acquired again
        fKeybdAcquired = TRUE;
        return TRUE;
}
#else
  /* Not using DirectInput */

int minit (void) { return 1;}
void mdeinit (void) {}
void msetbounds (int x0, int y0, int x1, int y1) {}
void msetxy (int x0, int y0) {}
void noclick (void) {}
void PR_ReadMouse (void) {}
void PR_MouseSyncAcquire (HWND hwnd) {}
int installkbd (void) { fKeybdAcquired = TRUE; return 1;}
void PR_ReadKeyboard(void) {}
void uninstallkbd (void) { fKeybdAcquired = FALSE; }
BOOL PR_KeyboardSyncAcquire (void) { return 1; }
#endif


/* OpenGL specific stuff */
extern HDC   PRGL_DC;
extern HGLRC PRGL_RC;

void wgt_log_message (char *msg, ... );



void resize (GLsizei width, GLsizei height)
{
  glViewport(0, 0, width, height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0.0f, (GLfloat) width, 0.0f, (GLfloat) height, -1.0f, 1.0f);
  glScalef(1, -1, 1);           /* Invert Y axis so increasing Y goes down. */
  glTranslatef(0, -height, 0);  /* Shift origin up to upper-left corner. */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  /* Need this so clipping is done correctly */
  PR_OutputDevice.width = width;
  PR_OutputDevice.height = height;

  if (active_viewport.width > 0)
    PR_ResizeViewport (&active_viewport, 0, 0, width-1, height-1);


  if (PR_CurrentCamera != NULL)
    PR_CurrentCamera->aspect_ratio = (PR_REAL)width / (PR_REAL)height;
}


void PR_RestoreAll (void)
{
int cx, cy;

  cx = GetSystemMetrics (SM_CXSCREEN);
  cy = GetSystemMetrics (SM_CYSCREEN);
  
  #ifdef USE_FULL_SCREEN
   SetWindowPos (hWndMain, HWND_TOP, 0, 0, cx, cy, SWP_SHOWWINDOW);
   resize (cx, cy);
   PR_LostSurface = 0;
  #endif
}


long FAR PASCAL MainWndproc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
PAINTSTRUCT ps;
HDC         hdc;
LRESULT     lRc;
RECT        rect;

    switch (message)
    {
     case WM_CREATE:
       break;

    case WM_SIZE:
          #ifndef USE_FULL_SCREEN
          GetClientRect(hWnd, &rect);
          resize(rect.right, rect.bottom);
          #endif
          break;

    case WM_CLOSE:
        
          PR_ShutdownGL ();
          ChangeDisplaySettings (NULL, 0);
          DestroyWindow (hWnd);
          exit(1);
          break;

    case WM_DESTROY:
          PR_ShutdownGL ();
          ChangeDisplaySettings (NULL, 0);
          PostQuitMessage (0);
          break;

/*
    case WM_SETCURSOR:
         SetCursor(NULL);
         return 0;
         break;
*/
    case WM_KEYDOWN:

         if(!fKeybdAcquired)
           {
            keyqueue[keyhead++] = wParam & 0xFF; 
            keyhead &= 255;
            return 0;
           }
                 #if !defined (USE_DIRECT_INPUT)
                 else
           {
                kbdon[wParam]=TRUE;
                   }
                 #endif
        break;

    case WM_KEYUP:
                 #if !defined (USE_DIRECT_INPUT)
         if(fKeybdAcquired)
                kbdon[wParam]=FALSE;
                 #endif
         return 0;
         break;
    
    case WM_ACTIVATE:
        {
         WORD fActive = LOWORD(wParam);
         BOOL fMinimized = (BOOL) HIWORD(wParam);

         if ( ( fActive == WA_INACTIVE ) || fMinimized ) 
             {
              //PR_AppActive = FALSE;
              PR_MouseSyncAcquire (hWnd);
             } 
         else if ((fActive == WA_ACTIVE) || (fActive == WA_CLICKACTIVE))
             {
              //PR_AppActive = TRUE;
              PR_MouseSyncAcquire(hWnd);
              PR_KeyboardSyncAcquire();
              SetForegroundWindow (hWnd);
             }
            return 0;
       }
       break;



    case WM_ENTERMENULOOP:
    case WM_ENTERSIZEMOVE:
         PR_AppActive = FALSE;
         PR_MouseSyncAcquire(hWnd);
         PR_KeyboardSyncAcquire();
         break;

    case WM_EXITMENULOOP:
    case WM_EXITSIZEMOVE:
         PR_AppActive = GetActiveWindow() == hWnd;
                 #ifdef USE_DIRECT_INPUT
         PostMessage(hWnd, WM_SYNCACQUIRE, 0, 0L);
         break;

    case WM_SYNCACQUIRE:
         PR_MouseSyncAcquire (hWnd);
         PR_KeyboardSyncAcquire();
         break;
                 #endif

    case WM_PAINT:
                hdc = BeginPaint( hWnd, &ps );
        EndPaint( hWnd, &ps );
        return 1;

    case WM_MOVE:
                break;

    case WM_SYSCOMMAND:
      switch (GET_WM_COMMAND_ID(wParam, lParam)) 
        {
         case SC_SCREENSAVE:
         break;
        
         default:
         lRc = DefWindowProc(hWnd, message, wParam, lParam);
         break;
        }
        
     if (IsWindow(hWnd)) 
       {
        PR_MouseSyncAcquire (hWnd);
        PR_KeyboardSyncAcquire();
       }
    return lRc;

    default:
        break;
    }
    return DefWindowProc(hWnd, message, wParam, lParam);

} /* MainWndproc */

/*
 * initApplication
 *
 * Do that Windows initialization stuff...
 */
static BOOL initApplication( HANDLE hInstance, int nCmdShow )
{
    WNDCLASS    wc;
    BOOL        rc;

    ghInstance = hInstance;

#ifdef USE_FULL_SCREEN
    PR_Settings.UseWindowed = 0;
#else
    PR_Settings.UseWindowed = 1;
#endif

#ifdef USE_ZBUFFER
    PR_Settings.UseZbuffer = 1;
#else
    PR_Settings.UseZbuffer = 0;
#endif

#ifdef USE_BILINEAR
    PR_Settings.UseBilinear = 1;
#else
    PR_Settings.UseBilinear = 0;
#endif

    wc.style = 0;
    wc.lpfnWndProc = MainWndproc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon( NULL, IDI_APPLICATION);    /* generic icon */
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = GetStockObject (BLACK_BRUSH);
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = "PRClass";
    rc = RegisterClass( &wc );
    if( !rc )
    {
        return FALSE;
    }


    hWndMain = CreateWindowEx(
#ifdef USE_FULL_SCREEN
        WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
#else
        WS_OVERLAPPEDWINDOW, 
#endif
        "PRClass",
        TITLE,
#ifdef USE_FULL_SCREEN
        WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
#else
        WS_OVERLAPPEDWINDOW,      
#endif

        CW_USEDEFAULT, 
        CW_USEDEFAULT,
        640,
        480,                
        NULL,
        NULL,
        hInstance,
        NULL );



    if (!hWndMain)
      {
       return FALSE;
      }

    if (!minit ()) 
       {
        DestroyWindow(hWndMain);
        return 0;
       }

    ShowWindow (hWndMain, SW_NORMAL);
    UpdateWindow (hWndMain);
    
    BringWindowToTop (hWndMain);
    SetFocus (hWndMain);
        
    PR_AppActive = TRUE;
    PR_MouseSyncAcquire (hWndMain);
    return TRUE;
} /* initApplication */

/*
 * WinMain
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, 
    LPSTR lpCmdLine, int nCmdShow )
{
LPSTR realcommand;

        if( !initApplication(hInstance, nCmdShow) )
        return FALSE;

    {
        int     argc;
        char    **argv;

#ifdef __WATCOMC__
        extern int WatMain(int argc, char **argv);
#else
        extern int main(int argc, char **argv);
#endif
                realcommand = GetCommandLine ();
        argv = commandLineToArgv(realcommand, &argc);
 
        PRGUI_InitPath (argv[0]);

#ifdef __WATCOMC__
        WatMain (argc, argv);
#else
        main (argc, argv);
#endif
    }

    mdeinit ();
    ChangeDisplaySettings (NULL, 0);
    DestroyWindow(hWndMain);
   return 0;

} /* WinMain */



/*
 * Converts lpCmdLine to WinMain into argc, argv
 */
static char    *argvbuf[32];
static char    cmdLineBuffer[1024];
char **
commandLineToArgv(LPSTR lpCmdLine, int *pArgc)
{
    char    *p, *pEnd;
    int     argc = 0;

    if (lpCmdLine == NULL) {
        *pArgc = argc;
         return argvbuf;
    }

    strcpy(cmdLineBuffer, lpCmdLine);
    p = cmdLineBuffer;
    pEnd = p + strlen(cmdLineBuffer);
    if (pEnd >= &cmdLineBuffer[1022]) pEnd = &cmdLineBuffer[1022];

    fflush (stdout);

    while (1) {
        /* skip over white space */
        fflush(stdout);

        while (*p == ' ') p++;
        if (p >= pEnd) break;

        while (*p == '\"') p++;
        if (p >= pEnd) break;

        argvbuf[argc++] = p;
        if (argc >= 32) break;

        /* skip till there's a 0 or a white space */
        while (*p && (*p != ' ')) p++;
                

        if (*p == ' ') *p++ = 0;
                if (*p == '\"') *p++ = 0;
    }

    *pArgc = argc;
    return argvbuf;
}



void getWindowSize(float *width, float *height)
{
RECT    rect;

  if (hWndMain != NULL)
    {
     GetClientRect(hWndMain, &rect);
     *width = (float) rect.right;
     *height = (float) rect.bottom; 
    }
  else
   {
    *width = 40;
    *height = 40;
   }
}


/* This dispatches any messages waiting and
   waits in a loop if the application is not active. */
void UpdateMessages (void)
{
MSG msg;

  PR_ReadMouse ();
  PR_ReadKeyboard ();

  do {
  while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
  {
   TranslateMessage(&msg);
   DispatchMessage(&msg);      
  }
  } while (!PR_AppActive);
}



char PR_getch (void)
{
MSG     msg;
char    rv;

  if (keytail != keyhead)
    {
     rv = keyqueue[keytail++];
     keytail &= 255;
     return rv;
    }

  while (GetMessage( &msg, NULL, 0, 0 ))
    {
     TranslateMessage (&msg);
     DispatchMessage (&msg);

     if (keytail != keyhead)
       {
        rv = keyqueue[keytail++];
        keytail &= 255;
        return rv;
       }
    }
   return rv;
}


int PR_kbhit (void)
{
MSG msg;

  if (keyhead != keytail)
    return 1;

  while (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
    {
     TranslateMessage (&msg);
     DispatchMessage (&msg);      /* this might change keyhead */
     if (keyhead != keytail)
       return 1;
    }
  return 0;
}

